 /****************************************************************************
 *
 *  Checker error numbers
 *
 ****************************************************************************/

/*{{{  copyright*/
/******************************************************************************
*
*  occam 2 compiler
*
*  copyright Inmos Limited 1987
*
******************************************************************************/
/*}}}*/

#define CHK_OK 0
#define CHK_UNKNOWN_TYPE 1
#define CHK_TYPES_DIFF 2
#define CHK_INVTYPE 3
#define CHK_INVCOUNT 4
#define CHK_INV_EXACT 5
#define CHK_INV_ROUND_TRUNC 6
#define CHK_ASS_UNBALANCED 7
#define CHK_INV_SUBSCRIPT 8
#define CHK_INVTYPE_ASS 9
#define CHK_ABBR_TYPE_MISMATCH 10
/*#define CHK_UNKNOWN_NODE 11*/
#define CHK_INVTYPE_FRESULT 12
#define CHK_TOOMANYEXPS 13
#define CHK_TOOFEWEXPS 14
#define CHK_RETYPE_TYPE_MISMATCH 15
#define CHK_INV_FUNC_LIST 16
#define CHK_INV_VALOF_LIST 17
#define CHK_ADIM_NOT_CONST 18
#define CHK_ADIM_NOT_INT 19
#define CHK_INV_PROT 20
/*#define CHK_INVTYPETAG 21*/
#define CHK_TOO_FEW_VARS 22
#define CHK_TOO_MANY_VARS 23
/*#define CHK_INV_SIZE_OPERAND 24*/
#define CHK_CFOLD_OFLOW 25
#define CHK_NAMENOTCONST 26
#define CHK_NAMENOTARRAY 27
#define CHK_SUBSCRIPT_NOTCONST 28
#define CHK_SUBSCRIPT_OUT_OF_RANGE 29
#define CHK_INV_DECL_TAG 30
#define CHK_ADIM_NEGATIVE 31
#define CHK_ADIM_TOOBIG 32
#define CHK_INV_CONSTRUCT 33
#define CHK_INV_LIST 43
#define CHK_INV_SEGMENT_OPERAND 44
/*#define CHK_SLENGTH_NOT_CONST 45*/
#define CHK_ADIM_MISSING 46
#define CHK_INVTYPE_SPEC 47
/*#define CHK_INV_EXP 48*/
#define CHK_INVTYPE_CONSTEXP 49
#define CHK_EXP_NOT_CONST 50
#define CHK_TOO_MANY_ELSES 51
#define CHK_MULTIPLE_CASE 52
#define CHK_INVTYPE_SELECTOR 53
#define CHK_INVTYPE_SELN 54
#define CHK_SELN_NOTCONST 55
#define CHK_UNRESOLVED_INTTYPE 56
#define CHK_UNRESOLVED_REALTYPE 57
#define CHK_TYPE_MISMATCH 58
#define CHK_ASUB_NOT_INT 59
#define CHK_FN_VAR_PARAM 60
#define CHK_PTYPE_MISMATCH 61
#define CHK_TOO_FEW_PITEMS 62
#define CHK_TOO_MANY_PITEMS 63
#define CHK_BAD_PTAG 64
#define CHK_INVTYPE_STARTEXP 65
#define CHK_INVTYPE_LENGTHEXP 66
#define CHK_REPL_NOT_CONST 67
#define CHK_REPL_NEGATIVE 68
#define CHK_INVTYPE_GUARD 69
/*#define CHK_INV_CONFIG 70*/
#define CHK_INV_VAL 71
#define CHK_NAME_NOT_PROC 72
#define CHK_INVTYPE_PARAM 73
#define CHK_TOO_FEW_ACTUALS 74
#define CHK_TOO_MANY_ACTUALS 75
#define CHK_INVVARIABLE_PARAM 76
#define CHK_INV_CINDEX 77
#define CHK_NOT_CHANNEL 78
#define CHK_INV_TIMER_INPUT 79
#define CHK_TIME_TYPE_MISMATCH 80
#define CHK_NOT_CHANNEL_OR_TIMER 81
#define CHK_NOT_TIMER 82
#define CHK_INV_PORT_PROT 83
#define CHK_INDISTINCT_TAG 84
#define CHK_NOT_A_TAG 85
#define CHK_LOST_VARIANT 86
#define CHK_NAME_NOT_FUNCTION 87
#define CHK_LOST_VALOF 88
#define CHK_VALOF_SCOPE 89
#define CHK_BAD_VALOF 90
#define CHK_VALOF_CALL_SCOPE 91
#define CHK_SUBSCRIPT_RANGE 92
#define CHK_SEG_START_RANGE 93
#define CHK_SEG_LENGTH_RANGE 94
#define CHK_SEG_RANGE 95
/*#define CHK_CONSTANT_SEGMENT_ERROR 96*/
#define CHK_BAD_PLACE_NAME 97
#define CHK_INVTYPE_PLACEMENT 98
#define CHK_TOO_MANY_MULTIVALUES 99
#define CHK_NAME_NOT_DECLARED 100
#define CHK_TAG_CONFLICT 101
#define CHK_BAD_FUNCTION_TYPE 102
#define CHK_BAD_INPUT_PROTOCOL 103
#define CHK_BAD_CASE_INPUT_PROTOCOL 104
#define CHK_BAD_TAGGED_INPUT_PROTOCOL 105
#define CHK_ALT_INPUT_PORT 106
#define CHK_BAD_WSPLACE 107
#define CHK_NAME_MULTIPLY_PLACED 108
#define CHK_MULTIPLE_VARIANT 109
#define CHK_TOO_MANY_TAGS 110
#define CHK_BAD_DEST 111
#define CHK_BAD_COUNT 112
#define CHK_COUNT_OUT_OF_RANGE 113
#define CHK_BAD_INLINE_NAME 114
/*#define CHK_ENTRYPOINT_NOT_FOUND 115*/
/*#define CHK_NAME_STACK_OVERFLOW 116*/
#define CHK_BAD_GUY_OPERAND 117
#define CHK_DISABLED_GUYCODE 118
#define CHK_INVALID_GUYCODE 119
#define CHK_BAD_GUYCODE 120
#define CHK_BAD_STEPCODE 121
#define CHK_MISSING_OPERAND 122
#define CHK_EXTRANEOUS_OPERAND 123
#define CHK_BAD_VALOF_CALL 124
#define CHK_INVTYPE_PROCEXP 125
/*#define CHK_INVPROCTYPE 126*/
#define CHK_NESTED_PRI_PAR 127
#define CHK_NESTED_PRI_PROC 128
#define CHK_INV_PRI_PAR 129
#define CHK_NO_PRI_REPL_PAR 130
#define CHK_UNKNOWN_CONSTRUCTOR_SIZE 131
#ifdef CONDEXP
#define CHK_CONDEXP_NOT_BOOL 132
#endif
#define CHK_INV_ABBR 133
#define CHK_CONSTRUCTOR_TYPE_MISMATCH 134
#define CHK_ASS_NAME_USED_MULTIPLY 135
#define CHK_INV_RETYPE 136
#define CHK_NAME_NOT_USED 137
#define CHK_PARAM_NOT_USED 138
#define CHK_ROUTINE_NOT_USED 139
#define CHK_BAD_VALRETYPE       140
#define CHK_BAD_CHANRETYPE      141
#define CHK_RETYPE_NOTYPE       142
#define CHK_BAD_DEST_CONSTRUCTOR        143
#define CHK_BAD_DEST_STRING             144
#define CHK_INV_SHIFT                   145
#define CHK_INV_MULTIASSIGN             146
#define CHK_ASM_TOO_BIG                 147
#define CHK_UNIMPLEMENTED_ASMCODE       148
/*#define CHK_LABEL_INSIDE_INLINE         149*/
#define CHK_NAME_IS_DESCOPED            150
#define CHK_ARRAY_SIZE_OVERFLOW         151
#define CHK_RSUB_NOT_FIELD              152
#define CHK_LONELY_FIELD                153
#define CHK_LIB_WRONG_TARGET            154
#define CHK_BAD_ANY_PROT                155
#define CHK_ASM_BAD_STORE               156
#define CHK_INV_ASSERT                  157

#ifdef CONFIG
/* Configuration errors */

#define CHK_ILLEGAL_CONFIG_CONSTRUCT    200
#define CHK_ILLEGAL_CONSTRUCT           201
#define CHK_DUPLICATE_CONSTRUCT         202
#define CHK_ZERO_CONSTRUCT              203
#define CHK_INVTYPE_EDGE                204
#define CHK_INVTYPE_ARC                 205
#define CHK_INVTYPE_DEVICE              206
#define CHK_INVTYPE_ATTR                207
#define CHK_INV_MAPPING_RHS             208
#define CHK_INV_MAPPING_LHS             209
#define CHK_INV_MAPPING_PRI             210
#define CHK_INV_MAPPING_NOPRI           211
#define CHK_INV_PLACEON_RHS             212
#define CHK_ILLEGAL_PLACE               213
#define CHK_CALLING_CONVENTION          214

#define CONF_CANNOT_EVAL_LINKNUM        250
#define CONF_CANNOT_EVAL_EXP            251
#define CONF_EVAL_STOP                  252
#define CONF_NAME_LINK_CONNECTED        253
#define CONF_EDGE_CONNECTED             254
#define CONF_ARC_ALREADY_USED           255
#define CONF_BAD_LINKNUM                256
#define CONF_CHAN_MULTIPLY_USED         257
#define CONF_ILLEGAL_PROCTYPE           258
#define CONF_ILLEGAL_MEMVAL             259
#define CONF_DUPLICATE_PROCTYPE         260
#define CONF_DUPLICATE_MEMVAL           261
#define CONF_NO_PROCTYPE                262
#define CONF_NO_MEMVAL                  263
#define CONF_NOT_CONNECTED              264
#define CONF_INVALID_PROTOCOL           265
#define CONF_NO_ROUTE                   266
#define CONF_FULL_ROUTE                 267
#define CONF_ILLEGAL_PRIVAL             268
#define CONF_NAME_ALREADY_MAPPED        269
#define CONF_LOGICAL_IS_PHYSICAL        270
#define CONF_LOGICAL_NOT_MAPPED         271
#define CONF_REQUIRE_PHYSICAL_NODE      272
#define CONF_ARC_NOT_CONNECTED          273
#define CONF_ARC_WRONGLY_CONNECTED      274
#define CONF_ARC_FULL_INPUT             275
#define CONF_ARC_FULL_OUTPUT            276
#define CONF_NO_ROOT                    277
#define CONF_DUPLICATE_ROOT             278
#define CONF_ROOT_NOT_ARRAY             279
#define CONF_ILLEGAL_ROMSIZE            280
#define CONF_NO_ROMSIZE                 281
#define CONF_DUPLICATE_ROMSIZE          282
#define CONF_CHAN_NO_DIRECTION          283
#define CONF_CHAN_ABBR_REPL             284
#define CONF_ARC_NO_EDGE                285
#define CONF_DECL_REPL                  286
#define CONF_DUPLICATE_ORDERINFO        287
#define CONF_ORDER_IGNORED              288
#define CONF_NESTED_PRI_PAR             289
#define CONF_NO_HOST_CHAN               290
#define CONF_SUBSCRIPT_OUT_OF_RANGE     291

#endif
